<template lang="html">
  <div id="register">
    <h1 class="title is-2">
      Inscription
    </h1>
    <form ref="form" class="box">
      <b-field label="Nom complet">
        <b-input v-model="name"></b-input>
      </b-field>
      <b-field label="Nom d'utilisateur *"  message="Veuillez ne pas utiliser d'espaces dans votre nom d'utilisateur, de point virgule ou de virgule.">
        <b-input v-model="username"></b-input>
      </b-field>
      <b-field label="Type d'utilisation *">
        <div id="radio-wrapper">
          <b-radio-button v-model="type"
              native-value="artiste"
              type="is-danger">
              <span>Artiste</span>
          </b-radio-button>
          <b-radio-button v-model="type"
              native-value="exposant"
              type="is-link">
              <span>Exposant</span>
          </b-radio-button>

          <b-radio-button v-model="type"
              native-value="explorateur">
              Explorateur
          </b-radio-button>
        </div>
      </b-field>
      <b-field label="Adresse email *">
        <b-input type="email" v-model="email" id="email-register"></b-input>
      </b-field>
      <b-field label="Mot de passe *">
        <b-input type="password" v-model="password"></b-input>
      </b-field>
      <div id="submit-ctn" class="control">
        <button class="is-disable button is-danger is-medium" :disabled="!checkValidity" @click="register($event)">Inscription</button>
      </div>
    </form>
  </div>
</template>

<script>
import { mapActions } from 'vuex'
export default {
  name:'Register',
  data(){
    return {
      name:null,
      username:null,
      email:null,
      password:null,
      type:null
    }
  },
  computed:{
    checkValidity(){
      var regEmail = /\S+@\S+/;
      var testUsername = this.username && !this.username.includes(' ') & !this.username.includes(';') && !this.username.includes(',');
      var regEmailtest = regEmail.test(String(this.email).toLowerCase())
      return regEmailtest && testUsername && this.password && this.type;
    }
  },
  methods: {
    ...mapActions('profile',['registerProfile']),
    register(event) {
      event.preventDefault()
      var creds = {
        username: this.username,
        name: this.name,
        email: this.email,
        password: this.password,
        type: this.type
      };
      this.registerProfile(creds);
    }
  }
}
</script>

<style lang="scss">
#register{
  padding-top: 2rem;
  margin: auto;
  width: 70%;
    #radio-wrapper{
      display: flex;
    }
    #submit-ctn {
      margin-top: 2rem;
      button{
        width: 100%;
      }
    }
}
</style>
